#define PATHL	81
#define NAMELEN	12
#define MAXDENT	2500

struct dirent {
	char	*name;
	unsigned	attr;
	unsigned	time;
	unsigned	date;
	long	size;
};

#define E_TAGGED	0x100


struct dir {
	char	*path;
	int	nfile;
	struct dirent	*entries;
};


struct dirwin {
	int	x, y, xl, yl;
	int	top, curr;
	int	master;
	char	fmt[64];
	char	pattern[NAMELEN+1];
	struct dir	*dir;
	struct viobuf	*bg;
};


struct dir	*dir2mem(char *path, char *pattern);
char		*dirstr(struct dirent *dir, char *fmt);
void		dir_destroy(struct dir *dir);
void		dw_bar(struct dirwin *dw, int on);
void		dw_show(struct dirwin *dw);
void		dw_hide(struct dirwin *dw);
struct dirwin	*dw_open(int x, int y, int len, char *path, char *pattern, \
		char *fmt, int master);
void		dw_close(struct dirwin *dw);
int		dw_move(struct dirwin *dw, int k);
int		dw_action(struct dirwin *dw, int k);
