#include <alloc.h>
#include "xmem.h"


void *xmalloc(unsigned size) {
	char	*new;

	if ((new = malloc(size)) == NULL) nomem();
	return(new);
}


void xfree(void *arena) {
	free(arena);
}


void *xrealloc(void *arena, unsigned newsize) {
	if (!newsize) {
		xfree(arena); return(NULL);
	}
	if ((arena = realloc(arena, newsize)) == NULL)
		nomem();
	return(arena);
}


char *xsave(char *s) {
	char	*new;

	new = xmalloc(strlen(s)+1);
	strcpy(new, s);
	return(new);
}
