#define vio_size(x, y, dx, dy)	(((dx)-(x)+1) * ((dy)-(y)+1) * 2)

#define MAXHIST		12

struct viobuf {
	int	x, y, dx, dy;
	int	cx, cy;
	char	*vbuf;
};

extern unsigned	vio_base,
		vio_x,
		vio_y,
		vio_attr,
		vio_lines,
		vio_cols,
		vio_clipx,
		vio_cksnow;

extern struct dirwin	*Cmd_ext;
extern int		Cmd_fcomp;

void	vio_init();
void	vio_move(int x, int y);
void	vio_sync();
void	vio_color(unsigned color);
void	vio_putc(unsigned c);
void	vio_puts(char *s);
void	vio_clear();
void	vio_clreol();
void	vio_index(int x, int y, int dx, int dy);
void	vio_revind(int x, int y, int dx, int dy);
int	vio_getcx();
int	vio_getcy();
int	vio_getc();
int	vio_mono();
int	vio_query();
void	vio_save(int x, int y, int dx, int dy, char *buf);
void	vio_rest(int x, int y, int dx, int dy, char *buf);

struct viobuf	*vio_protect(int x, int y, int dx, int dy);
void		vio_hide(struct viobuf *vbuf);
void		vio_alert(int x, int y, char *msg, int timeout);
int		vio_prompt(int x, int y, int dx, int tc, int hc, int fc, \
		int len, char *buf, char *title);
int		vio_menu(int x, int y, int txc, int barc, int hotc, int dfl, \
		char *itemv);
